Index: trunk/drmaa_utils/m4/missing-dev-prog.sh
===================================================================
--- trunk/drmaa_utils/m4/missing-dev-prog.sh	(revision 1)
+++ trunk/drmaa_utils/m4/missing-dev-prog.sh	(revision 1)
@@ -0,0 +1,7 @@
+#!/bin/sh
+cat >&2 <<MESSAGE
+ * ERROR: $1 was not found at configuration time while some
+ * sources are build by it.  Either install $1 or download
+ * tarball with generated sources included.
+MESSAGE
+exit 1
Index: trunk/drmaa_utils/m4/ax_gettid.m4
===================================================================
--- trunk/drmaa_utils/m4/ax_gettid.m4	(revision 1)
+++ trunk/drmaa_utils/m4/ax_gettid.m4	(revision 1)
@@ -0,0 +1,53 @@
+# $Id$
+#
+# SYNOPSIS
+#
+#   AX_GETTID([ACTION-IF-FOUND[, ACTION-IF-NOT-FOUND]])
+#
+# DESCRIPTION
+#
+#   Check for gettid system call.  When found this macro
+#   defines HAVE_GETTID.  It may be used after following
+#   definition (it is not defined in Linux headers)::
+#
+#     #include <sys/types.h>
+#     #include <sys/syscall.h>
+#     pid_t gettid(void) {  return (pid_t)syscall( __NR_gettid );  }
+#
+# LAST MODIFICATION
+#
+#   2007-12-14
+#
+# LICENSE
+#
+#   Written by Åukasz CieÅnik <lukasz.ciesnik@fedstage.com>
+#   and placed under Public Domain
+#
+
+AC_DEFUN([AX_GETTID],[
+AC_MSG_CHECKING([for gettid])
+AC_REQUIRE([AC_PROG_CC])
+
+AC_LANG_PUSH([C])
+AC_COMPILE_IFELSE(
+	AC_LANG_PROGRAM([[
+@%:@include <sys/types.h>
+@%:@include <sys/syscall.h>
+@%:@include <unistd.h>
+pid_t gettid(void) { return (pid_t)syscall(__NR_gettid); }]],
+	[[pid_t tid = gettid(); return 0;]]),
+[ax_gettid_ok=yes], [ax_gettid_ok=no])
+AC_LANG_POP([C])
+
+AC_MSG_RESULT([$ax_gettid_ok])
+if test x$ax_gettid_ok = xyes; then
+	AC_DEFINE([HAVE_GETTID],1,[Define to 1 if you have the gettid() syscall.])
+fi
+if test x$ax_gettid_ok = xyes; then
+	$1
+	:
+else
+	$2
+	:
+fi
+])
Index: trunk/drmaa_utils/.ignore
===================================================================
--- trunk/drmaa_utils/.ignore	(revision 1)
+++ trunk/drmaa_utils/.ignore	(revision 1)
@@ -0,0 +1,29 @@
+configure
+Makefile.in
+Doxyfile
+config.log
+config.status
+scripts
+stamp-h1
+config.h
+config.h.in
+autom4te.cache
+drmaa_utils-2.0.1.tar.gz
+libtool
+aclocal.m4
+Makefile
+.libs
+.deps
+Makefile
+test_exception
+libtool.m4
+lt~obsolete.m4
+ltsugar.m4
+ltversion.m4
+ltoptions.m4
+drmaa_attrib.c
+datetime_tab.c
+datetime_tab.h
+timedelta.c
+conf_tab.c
+conf_tab.h
Index: trunk/drmaa_utils/configure.ac
===================================================================
--- trunk/drmaa_utils/configure.ac	(revision 1)
+++ trunk/drmaa_utils/configure.ac	(revision 1)
@@ -0,0 +1,204 @@
+AC_INIT([FedStage DRMAA utilities library], [2.0.1], [drmaa-pbspro-users@lists.fedstage.com], [drmaa_utils])
+AC_PREREQ(2.59)
+AC_REVISION([$Id: configure.ac 1673 2008-11-21 20:17:05Z lukasz $])
+AC_COPYRIGHT([
+FedStage DRMAA utilities library
+Copyright (C) 2006-2008  FedStage Systems
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+])
+
+DRMAA_UTILS_MAJOR=2
+DRMAA_UTILS_MINOR=0
+DRMAA_UTILS_MICRO=1
+DRMAA_UTILS_VERSION_INFO=2:1:0
+AC_SUBST([DRMAA_UTILS_MAJOR])
+AC_SUBST([DRMAA_UTILS_MINOR])
+AC_SUBST([DRMAA_UTILS_MICRO])
+AC_SUBST([DRMAA_UTILS_VERSION_INFO])
+
+AC_CONFIG_SRCDIR([drmaa_utils/xmalloc.c])
+AC_CONFIG_MACRO_DIR([m4])
+AC_CONFIG_AUX_DIR([scripts])
+
+AM_INIT_AUTOMAKE
+DEVELOPER_MODE="no"
+AM_CONDITIONAL([DEVELOPER_MODE], [test "x$DEVELOPER_MODE" = "xyes"])
+
+# command-line arguments:
+AC_ARG_ENABLE(debug, AC_HELP_STRING([--enable-debug],
+			[produce code suiteable for debugging and print logs at runtime]))
+AC_ARG_ENABLE(development, AC_HELP_STRING([--enable-development],
+			[enable development mode: make additional checks (suiteable for FedStage DRMAA utilities library developers)]))
+
+AC_ARG_WITH(drmaa-utils, AC_HELP_STRING([--with-drmaa-utils=...],
+		[used only to detect that drmaa utils is sub packaged]))
+AM_CONDITIONAL([DRMAA_UTILS_STANDALONE],
+		[test x$with_drmaa_utils = x])
+
+# programs:
+AC_PROG_CC
+AC_PROG_CPP
+AC_PROG_RANLIB
+AC_PROG_INSTALL
+AC_PROG_LIBTOOL
+AC_PROG_MAKE_SET
+AC_PROG_LN_S
+
+
+# code generation tools:
+AC_PROG_YACC
+AX_GPERF
+AC_CHECK_PROGS([RAGEL], [ragel], [sh m4/missing-dev-prog.sh ragel])
+
+# reStructuredText processing:
+AX_DOCUTILS
+# documentation generation:
+AC_CHECK_PROGS([DOT], [dot])
+if test x$DOT != x; then
+	HAVE_DOT=yes
+else
+	HAVE_DOT=no
+fi
+AC_SUBST([HAVE_DOT])
+
+# check compiler / set basic flags:
+if test x$ac_cv_prog_cc_stdc = xno; then
+	AC_MSG_ERROR([ANSI C compiler is required])
+fi
+
+if test x$GCC = xyes; then
+	CFLAGS="-pedantic -ansi ${CFLAGS}"
+fi
+AM_CONDITIONAL([GCC], [test x$GCC = xyes])
+
+AX_GCC_WARNINGS()
+
+AH_TEMPLATE([DEBUGGING], [Produce debugging code])
+if test x$enable_debug = xyes; then
+	AC_DEFINE(DEBUGGING,[1])
+	CFLAGS="${CFLAGS} -O0"
+else
+	CPPFLAGS="-DNDEBUG ${CPPFLAGS}"
+fi
+
+AH_TEMPLATE([DEVELOPMENT], [Development mode])
+if test x$enable_development = xyes; then
+	AC_DEFINE(DEVELOPMENT, [1])
+fi
+
+AH_BOTTOM([
+#ifndef __GNUC__
+#	define __attribute__ /* nothing */
+#endif
+])
+
+# system:
+CPPFLAGS="-D_REENTRANT -D_THREAD_SAFE ${CPPFLAGS}"
+
+AC_CANONICAL_HOST
+case "$host_os" in
+	*linux*)
+		CPPFLAGS="${CPPFLAGS} -D_GNU_SOURCE"
+		;;
+	*solaris*)
+		CPPFLAGS="${CPPFLAGS} -D_XOPEN_SOURCE=500 -D__EXTENSIONS__"
+		;;
+	*freebsd*)
+		;;
+	*darwin*)
+		CPPFLAGS="${CPPFLAGS} -D_XOPEN_SOURCE=400"
+		;;
+	*aix*)                                                                                                                                                                                                                                  
+		CPPFLAGS="${CPPFLAGS} -D_XOPEN_SOURCE=500 -D_XOPEN_SOURCE_EXTENDED=1 -D__linux__"  
+		;;
+	*)
+		CPPFLAGS="${CPPFLAGS} -D_XOPEN_SOURCE=500 -D__USE_BSD"
+		;;
+esac
+
+
+AC_C_BIGENDIAN_CROSS
+
+# project prerequisites:
+
+# libraries:
+ACX_PTHREAD([CFLAGS="$CFLAGS $PTHREAD_CFLAGS" LIBS="$PTHREAD_LIBS $LIBS"],
+		[AC_MSG_ERROR([POSIX threads library is required by DRMAA.])])
+
+# headers:
+AC_CHECK_HEADERS([execinfo.h fcntl.h inttypes.h libintl.h limits.h malloc.h stddef.h stdint.h stdlib.h string.h sys/time.h unistd.h])
+AC_HEADER_STDBOOL
+AC_HEADER_TIME
+
+# types and structures:
+AC_TYPE_PID_T
+AC_TYPE_SIZE_T
+AC_TYPE_SSIZE_T
+AC_TYPE_MODE_T
+AC_TYPE_UINT16_T
+AC_TYPE_UINT32_T
+AC_TYPE_UINT8_T
+AC_STRUCT_TM
+AC_CHECK_MEMBER(struct tm.tm_gmtoff,[AC_DEFINE([HAVE_STRUCT_TM_GMTOFF],[1],[gmtoff in struct tm])],,[#include <time.h>])
+
+# compiler characteristic
+AC_C_CONST
+AC_C_INLINE
+AC_C_VOLATILE
+
+# functions:
+AC_FUNC_ALLOCA
+AC_FUNC_STRERROR_R
+AC_FUNC_STRFTIME
+AC_CHECK_FUNCS([ \
+	asprintf \
+	fstat \
+	getcwd \
+	gettimeofday \
+	localtime_r \
+	memset \
+	strchr \
+	strdup \
+	strerror \
+	strlcpy \
+	strndup \
+	strstr \
+	vasprintf])
+AX_FUNC_GETTID
+AX_FUNC_VA_COPY
+AC_SEARCH_LIBS([backtrace], [execinfo])
+
+# system services:
+
+# turn on warning after all tests
+if test x$GCC = xyes; then
+	if test x$enable_development = xyes; then
+		CFLAGS="-Werror ${CFLAGS}"
+	fi
+	CFLAGS="-Wall -W -Wno-unused  $GCC_W_NO_FORMAT_ZERO_LENGTH  $GCC_W_NO_MISSING_FIELD_INITIALIZERS ${CFLAGS}"
+fi
+
+AC_CONFIG_FILES([
+	Makefile
+	drmaa_utils/Makefile
+	test/Makefile
+	Doxyfile
+])
+AC_CONFIG_HEADERS([config.h])
+AC_OUTPUT
+
+echo
+echo "Run 'make' now."
+
Index: trunk/drmaa_utils/autoclean.sh
===================================================================
--- trunk/drmaa_utils/autoclean.sh	(revision 1)
+++ trunk/drmaa_utils/autoclean.sh	(revision 1)
@@ -0,0 +1,24 @@
+#!/bin/sh
+# $Id: autoclean.sh 1656 2008-11-18 17:11:58Z lukasz $
+
+echo "Removing all generated files. ($PWD)"
+
+make maintainer-clean
+
+rm -f aclocal.m4 configure configure.scan config.h.in confdefs.h libtool
+
+rm -rf autom4te.cache
+rm -rf scripts
+
+find . -name Makefile.in -exec rm -f {} \;
+find . -name Makefile -exec rm -f {} \;
+find . -name \*~ -exec rm -f {} \;
+find . -name \.#* -exec rm -f {} \;
+find . -name \*.core -exec rm -f {} \;
+find . -name \*.log -exec rm -f {} \;
+find . -name \*.a -exec rm -f {} \;
+find . -name \*.o -exec rm -f {} \;
+find . -name \*.lo* -exec rm -f {} \;
+find . -name \*.la* -exec rm -f {} \;
+
+echo "done."
Index: trunk/drmaa_utils/drmaa_utils/xmalloc.h
===================================================================
--- trunk/drmaa_utils/drmaa_utils/xmalloc.h	(revision 1)
+++ trunk/drmaa_utils/drmaa_utils/xmalloc.h	(revision 1)
@@ -0,0 +1,88 @@
+/* $Id: xmalloc.h 2 2009-10-12 09:51:22Z mamonski $ */
+/*
+ *  FedStage DRMAA utilities library
+ *  Copyright (C) 2006-2008  FedStage Systems
+ *
+ *  This program is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+/**
+ * @file xmalloc.h
+ * Memory allocation/deallocation routines.
+ */
+
+#ifndef __DRMAA_UTILS__XMALLOC_H
+#define __DRMAA_UTILS__XMALLOC_H
+
+#ifdef HAVE_CONFIG_H
+#	include <config.h>
+#endif
+
+#include <drmaa_utils/compat.h>
+
+/**
+ * @defgroup xmalloc  Memory allocation/deallocation routines.
+ */
+/* @{ */
+
+
+/**
+ * Allocates <code> sizeof(type) </code> bytes.  Address of block is stored
+ * in @a p.  Upon failure FSD_ERRNO_NO_MEMORY is raised and @a p is NULL.
+ */
+#define fsd_malloc( p, type ) \
+	fsd_malloc_( (void**)(void*)&(p), sizeof(type) )
+
+/**
+ * Allocates <code> n * sizeof(type) </code> bytes of memory and stores
+ * address in \a p.  Allocated block is filled with zeros.  Upon failure
+ * error FSD_ERRNO_NO_MEMORY is raised.
+ * \c NULL is assigned to \a p on error or when <code> n == 0 </code>.
+ */
+#define fsd_calloc( p, n, type ) \
+	fsd_calloc_( (void**)(void*)&(p), (n), sizeof(type) )
+
+#define fsd_realloc( p, n, type ) \
+	fsd_realloc_( (void**)(void*)&(p), (n)*sizeof(type) )
+
+/**
+ * Fress previously allocated memory pointed by @a p.
+ * When <code> p == NULL </code> it does nothing.
+ */
+void fsd_free( void *p );
+
+void *fsd_malloc_( void **p, size_t size );
+void *fsd_calloc_( void **p, size_t n, size_t size );
+void *fsd_realloc_( void **p, size_t size );
+
+
+#define fsd_malloc_noraise( p, type ) \
+	fsd_malloc_noraise_( (void**)(void*)&(p), sizeof(type) )
+
+#define fsd_calloc_noraise( p, n, type ) \
+	fsd_calloc_noraise_( (void**)(void*)&(p), (n), sizeof(type) )
+
+#define fsd_realloc_noraise( p, n, type ) \
+	fsd_realloc_noraise_( (void**)(void*)&(p), (n)*sizeof(type) )
+
+#define fsd_free_noraise( p )  (fsd_free(p), 0)
+
+int fsd_malloc_noraise_( void **p, size_t size );
+int fsd_calloc_noraise_( void **p, size_t n, size_t size );
+int fsd_realloc_noraise_( void **p, size_t size );
+
+/* @} */
+
+#endif /* __DRMAA_UTILS__XMALLOC_H */
+
Index: trunk/drmaa_utils/drmaa_utils/fsd_job.c
===================================================================
--- trunk/drmaa_utils/drmaa_utils/fsd_job.c	(revision 1)
+++ trunk/drmaa_utils/drmaa_utils/fsd_job.c	(revision 1)
@@ -0,0 +1,461 @@
+/* $Id: fsd_job.c 308 2010-09-21 07:29:41Z mamonski $ */
+/*
+ * FedStage DRMAA utilities library
+ * Copyright (C) 2006-2008  FedStage Systems
+ *
+ * This program is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <string.h>
+
+#include <drmaa_utils/drmaa.h>
+#include <drmaa_utils/iter.h>
+#include <drmaa_utils/job.h>
+#include <drmaa_utils/lookup3.h>
+
+#ifndef lint
+static char rcsid[]
+#	ifdef __GNUC__
+		__attribute__ ((unused))
+#	endif
+	= "$Id: fsd_job.c 308 2010-09-21 07:29:41Z mamonski $";
+#endif
+
+
+static void fsd_job_release( fsd_job_t *self );
+static void fsd_job_destroy( fsd_job_t *self );
+static void fsd_job_control( fsd_job_t *self, int action );
+static void fsd_job_update_status( fsd_job_t *self );
+static void fsd_job_get_termination_status( fsd_job_t *self,
+			int *status, fsd_iter_t **rusage_out );
+static void fsd_job_on_missing( fsd_job_t *self );
+
+fsd_job_t *
+fsd_job_new( char *job_id )
+{
+	fsd_job_t *volatile self = NULL;
+	fsd_log_enter(( "(%s)", job_id ));
+	TRY
+	 {
+		fsd_malloc( self, fsd_job_t );
+		self->release = fsd_job_release;
+		self->destroy = fsd_job_destroy;
+		self->control = fsd_job_control;
+		self->update_status = fsd_job_update_status;
+		self->get_termination_status = fsd_job_get_termination_status;
+		self->on_missing = fsd_job_on_missing;
+		self->next              = NULL;
+		self->ref_cnt           = 1;
+		self->job_id            = job_id;
+		self->session           = NULL;
+		self->last_update_time  = 0;
+		self->flags             = 0;
+		self->state             = DRMAA_PS_UNDETERMINED;
+		self->exit_status       = 0;
+		self->submit_time       = 0;
+		self->start_time        = 0;
+		self->end_time          = 0;
+		self->cpu_usage         = 0;
+		self->mem_usage         = 0;
+		self->vmem_usage        = 0;
+		self->walltime          = 0;
+		self->execution_hosts   = NULL;
+		self->queue				= NULL;
+		self->project			= NULL;
+		fsd_mutex_init( &self->mutex );
+		fsd_cond_init( &self->status_cond );
+		fsd_cond_init( &self->destroy_cond );
+		fsd_mutex_lock( &self->mutex );
+	 }
+	EXCEPT_DEFAULT
+	 {
+		if( self )
+			self->destroy( self );
+		else
+			fsd_free( job_id );
+		fsd_exc_reraise();
+	 }
+	END_TRY
+	fsd_log_return(( "=%p: ref_cnt=%d [lock %s]",
+				(void*)self, self->ref_cnt, self->job_id ));
+	return self;
+}
+
+
+void
+fsd_job_release( fsd_job_t *self )
+{
+	bool destroy;
+	fsd_log_enter(( "(%p={job_id=%s, ref_cnt=%d}) [unlock %s]",
+				(void*)self, self->job_id, self->ref_cnt, self->job_id ));
+	fsd_assert( self->ref_cnt > 0 );
+	destroy = ( --(self->ref_cnt) == 0 );
+	fsd_mutex_unlock( &self->mutex );
+	if( destroy )
+		self->destroy( self );
+	fsd_log_return(( "" ));
+}
+
+
+void
+fsd_job_destroy( fsd_job_t *self )
+{
+	fsd_log_enter(( "(%p={job_id=%s})", (void*)self, self->job_id ));
+	fsd_cond_destroy( &self->status_cond );
+	fsd_cond_destroy( &self->destroy_cond );
+	fsd_mutex_destroy( &self->mutex );
+	fsd_free( self->job_id );
+	fsd_free( self->execution_hosts );
+	fsd_free( self->queue );
+	fsd_free( self->project );
+	fsd_free( self );
+	fsd_log_return(( "" ));
+}
+
+
+void
+fsd_job_control( fsd_job_t *self, int action )
+{
+	fsd_exc_raise_code( FSD_ERRNO_NOT_IMPLEMENTED );
+}
+
+void
+fsd_job_update_status( fsd_job_t *self )
+{
+	fsd_exc_raise_code( FSD_ERRNO_NOT_IMPLEMENTED );
+}
+
+void
+fsd_job_get_termination_status( fsd_job_t *self,
+			int *status, fsd_iter_t **rusage_out )
+{
+	fsd_iter_t* volatile rusage = NULL;
+
+	TRY
+	 {
+		if( rusage_out )
+		 {
+			rusage = fsd_iter_new( NULL, 0 );
+			rusage->append( rusage, fsd_asprintf(
+						"submission_time=%ld", (long)self->submit_time ) );
+			rusage->append( rusage, fsd_asprintf(
+						"start_time=%ld", (long)self->start_time ) );
+			rusage->append( rusage, fsd_asprintf(
+						"end_time=%ld", (long)self->end_time ) );
+			rusage->append( rusage, fsd_asprintf(
+						"cpu=%ld", self->cpu_usage ) );
+			rusage->append( rusage, fsd_asprintf(
+						"mem=%ld", self->mem_usage ) );
+			rusage->append( rusage, fsd_asprintf(
+						"vmem=%ld", self->vmem_usage ) );
+			rusage->append( rusage, fsd_asprintf(
+						"walltime=%ld", self->walltime ) );
+			rusage->append( rusage, fsd_asprintf(
+						"hosts=%s", self->execution_hosts ) );
+
+			if (self->queue) {
+				rusage->append( rusage, fsd_asprintf("queue=%s", self->queue ) );
+			}
+
+			if (self->project) {
+				rusage->append( rusage, fsd_asprintf("project=%s", self->project ) );
+			}
+		 }
+	 }
+	EXCEPT_DEFAULT
+	 {
+		if( rusage )
+			rusage->destroy( rusage );
+		if( rusage_out )
+			*rusage_out = NULL;
+		fsd_exc_reraise();
+	 }
+	ELSE
+	 {
+		if( status )
+			*status = self->exit_status;
+		if( rusage_out )
+			*rusage_out = rusage;
+	 }
+	END_TRY
+}
+
+void
+fsd_job_on_missing( fsd_job_t *self )
+{
+	fsd_log_warning(( "job %s missing from DRM queue", self->job_id ));
+}
+
+
+static void
+fsd_job_set_destroy( fsd_job_set_t *self );
+static void
+fsd_job_set_add( fsd_job_set_t *self, fsd_job_t *job );
+static void
+fsd_job_set_remove( fsd_job_set_t *self, fsd_job_t *job );
+static fsd_job_t *
+fsd_job_set_get( fsd_job_set_t *self, const char *job_id );
+static bool
+fsd_job_set_empty( fsd_job_set_t *self );
+static fsd_job_t *
+fsd_job_set_find_terminated( fsd_job_set_t *self );
+static char **
+fsd_job_set_get_all_job_ids( fsd_job_set_t *self );
+static void fsd_job_set_signal_all( fsd_job_set_t *self );
+
+
+fsd_job_set_t *
+fsd_job_set_new(void)
+{
+	fsd_job_set_t *volatile self = NULL;
+	const size_t initial_size = 1024;
+
+	fsd_log_enter(( "()" ));
+	TRY
+	 {
+		fsd_malloc( self, fsd_job_set_t );
+		self->destroy = fsd_job_set_destroy;
+		self->add = fsd_job_set_add;
+		self->remove = fsd_job_set_remove;
+		self->get = fsd_job_set_get;
+		self->empty = fsd_job_set_empty;
+		self->find_terminated = fsd_job_set_find_terminated;
+		self->get_all_job_ids = fsd_job_set_get_all_job_ids;
+		self->signal_all = fsd_job_set_signal_all;
+		self->tab = NULL;
+		self->n_jobs = 0;
+		fsd_calloc( self->tab, initial_size, fsd_job_t* );
+		self->tab_size = initial_size;
+		self->tab_mask = self->tab_size - 1;
+		fsd_mutex_init( &self->mutex );
+	 }
+	EXCEPT_DEFAULT
+	 {
+		if( self )
+		 {
+			fsd_free( self->tab );
+			fsd_free( self );
+		 }
+		fsd_exc_reraise();
+	 }
+	END_TRY
+
+	fsd_log_return(( " =%p", (void*)self ));
+	return self;
+}
+
+
+void
+fsd_job_set_destroy( fsd_job_set_t *self )
+{
+	unsigned i;
+	fsd_job_t *j;
+
+	fsd_log_enter(( "()" ));
+	for( i = 0;  i < self->tab_size;  i++ )
+		for( j = self->tab[i];  j != NULL;  )
+		 {
+			fsd_job_t *job = j;
+			j = j->next;
+			fsd_mutex_lock( &job->mutex );
+			job->release( job );
+		 }
+	fsd_free( self->tab );
+	fsd_free( self );
+	fsd_log_return(( "" ));
+}
+
+
+void
+fsd_job_set_add( fsd_job_set_t *self, fsd_job_t *job )
+{
+	uint32_t h;
+	fsd_log_enter(( "(job=%p, job_id=%s)", (void*)job, job->job_id ));
+	fsd_mutex_lock( &self->mutex );
+	h = hashstr( job->job_id, strlen(job->job_id), 0 );
+	h &= self->tab_mask;
+	job->next = self->tab[ h ];
+	self->tab[ h ] = job;
+	self->n_jobs++;
+	job->ref_cnt++;
+	fsd_mutex_unlock( &self->mutex );
+	fsd_log_return(( ": job->ref_cnt=%d", job->ref_cnt ));
+}
+
+
+void
+fsd_job_set_remove( fsd_job_set_t *self, fsd_job_t *job )
+{
+	fsd_job_t **pjob = NULL;
+	uint32_t h;
+
+	fsd_log_enter(( "(job_id=%s)", job->job_id ));
+	fsd_mutex_lock( &self->mutex );
+	TRY
+	 {
+		h = hashstr( job->job_id, strlen(job->job_id), 0 );
+		h &= self->tab_mask;
+		for( pjob = &self->tab[ h ];  *pjob;  pjob = &(*pjob)->next )
+		 {
+			if( *pjob == job )
+				break;
+		 }
+		if( *pjob )
+		 {
+			*pjob = (*pjob)->next;
+			job->next = NULL;
+			self->n_jobs--;
+			job->ref_cnt--;
+		 }
+		else
+			fsd_exc_raise_code( FSD_DRMAA_ERRNO_INVALID_JOB );
+	 }
+	FINALLY
+	 { fsd_mutex_unlock( &self->mutex ); }
+	END_TRY
+	fsd_log_return(( ": job->ref_cnt=%d", job->ref_cnt ));
+}
+
+
+fsd_job_t *
+fsd_job_set_get( fsd_job_set_t *self, const char *job_id )
+{
+	uint32_t h;
+	fsd_job_t *job = NULL;
+
+	fsd_log_enter(( "(job_id=%s)", job_id ));
+	fsd_mutex_lock( &self->mutex );
+	h = hashstr( job_id, strlen(job_id), 0 );
+	h &= self->tab_mask;
+	for( job = self->tab[ h ];  job;  job = job->next )
+		if( !strcmp( job->job_id, job_id ) )
+			break;
+	if( job )
+	 {
+		fsd_mutex_lock( &job->mutex );
+		fsd_assert( !(job->flags & FSD_JOB_DISPOSED) );
+		job->ref_cnt ++;
+	 }
+	fsd_mutex_unlock( &self->mutex );
+	if( job )
+		fsd_log_return(( "(job_id=%s) =%p: ref_cnt=%d [lock %s]",
+					job_id, (void*)job, job->ref_cnt, job->job_id ));
+	else
+		fsd_log_return(( "(job_id=%s) =NULL", job_id ));
+	return job;
+}
+
+
+bool
+fsd_job_set_empty( fsd_job_set_t *self )
+{
+	return self->n_jobs == 0;
+}
+
+
+fsd_job_t *
+fsd_job_set_find_terminated( fsd_job_set_t *self )
+{
+	fsd_job_t *job = NULL;
+	size_t i;
+	fsd_mutex_t* volatile mutex = & self->mutex;
+
+	fsd_log_enter(( "()" ));
+	fsd_mutex_lock( mutex );
+	TRY
+	 {
+		for( i = 0;  i < self->tab_size;  i++ )
+			for( job = self->tab[ i ];  job;  job = job->next )
+				if( job->state >= DRMAA_PS_DONE )
+					goto found;
+found:
+		if( job )
+		 {
+			fsd_mutex_lock( &job->mutex );
+			fsd_assert( !(job->flags & FSD_JOB_DISPOSED) );
+			job->ref_cnt ++;
+		 }
+	 }
+	FINALLY
+	 { fsd_mutex_unlock( mutex ); }
+	END_TRY
+	if( job )
+		fsd_log_return(( "() =%p: job_id=%s, ref_cnt=%d [lock %s]",
+					(void*)job, job->job_id, job->ref_cnt, job->job_id ));
+	else
+		fsd_log_return(( "() =%p", (void*)job ));
+	return job;
+}
+
+
+char **
+fsd_job_set_get_all_job_ids( fsd_job_set_t *self )
+{
+	fsd_job_t *job = NULL;
+	char** volatile job_ids = NULL;
+	/* size_t n_jobs = 0, capacity = 0; */
+	size_t i;
+	unsigned j = 0;
+	fsd_mutex_t* volatile mutex = & self->mutex;
+
+	fsd_log_enter(( "" ));
+	fsd_mutex_lock( mutex );
+	TRY
+	 {
+		fsd_calloc( job_ids, self->n_jobs+1, char* );
+		for( i = 0;  i < self->tab_size;  i++ )
+			for( job = self->tab[ i ];  job;  job = job->next )
+				job_ids[ j++ ] = fsd_strdup( job->job_id );
+		fsd_realloc( job_ids, j+1, char* );
+	 }
+	FINALLY
+	 {
+		fsd_mutex_unlock( mutex );
+		if( fsd_exc_get() )
+			fsd_free_vector( job_ids );
+	 }
+	END_TRY
+
+	fsd_log_return(( " =%p", (void*)job_ids ));
+	return job_ids;
+}
+
+
+void
+fsd_job_set_signal_all( fsd_job_set_t *self )
+{
+	fsd_job_t *volatile job = NULL;
+	fsd_mutex_t *volatile mutex = & self->mutex;
+
+	fsd_log_enter(( "" ));
+	fsd_mutex_lock( mutex );
+	TRY
+	 {
+		volatile size_t i;
+		for( i = 0;  i < self->tab_size;  i++ )
+			for( job = self->tab[ i ];  job;  job = job->next )
+			 {
+				fsd_mutex_lock( &job->mutex );
+				TRY{ fsd_cond_broadcast( &job->status_cond ); }
+				FINALLY{ fsd_mutex_unlock( &job->mutex ); }
+				END_TRY
+			 }
+	 }
+	FINALLY
+	 { fsd_mutex_unlock( mutex ); }
+	END_TRY
+
+	fsd_log_return(( "" ));
+}
+
